import{s as Fe,o as Ie,n as Xe}from"../chunks/scheduler.0f20f9e5.js";import{S as Ze,i as je,g as s,s as a,r as h,A as Ue,h as o,f as i,c as l,j as Re,u as b,x as r,k as Ee,y as Ge,a as n,v as g,d as $,t as T,w as y}from"../chunks/index.fbd8b8e3.js";import{T as Qe}from"../chunks/Tip.1ed3d6e3.js";import{C as Ne}from"../chunks/CodeBlock.c14486c2.js";import{H as Q}from"../chunks/Heading.2451f3bb.js";function Se(S){let f,v="<strong>Beware: bf16 is the optimal compute data type!</strong>",u,m,d="If your hardware supports it, <code>bf16</code> is the optimal compute dtype. The default is <code>float32</code> for backward compatibility and numerical stability. <code>float16</code> often leads to numerical instabilities, but <code>bfloat16</code> provides the benefits of both worlds: numerical stability equivalent to float32, but combined with the memory footprint and significant computation speedup of a 16-bit data type. Therefore, be sure to check if your hardware supports <code>bf16</code> and configure it using the <code>bnb_4bit_compute_dtype</code> parameter in BitsAndBytesConfig:";return{c(){f=s("p"),f.innerHTML=v,u=a(),m=s("p"),m.innerHTML=d},l(p){f=o(p,"P",{"data-svelte-h":!0}),r(f)!=="svelte-ugrp4n"&&(f.innerHTML=v),u=l(p),m=o(p,"P",{"data-svelte-h":!0}),r(m)!=="svelte-nj78a"&&(m.innerHTML=d)},m(p,c){n(p,f,c),n(p,u,c),n(p,m,c)},p:Xe,d(p){p&&(i(f),i(u),i(m))}}}function Ve(S){let f,v,u,m,d,p,c,Te="With Transformers it’s very easy to load any model in 4 or 8-bit, quantizing them on the fly with bitsandbytes primitives.",V,_,ye='Please review the <a href="https://huggingface.co/docs/transformers/v4.37.2/en/quantization#bitsandbytes" rel="nofollow">bitsandbytes section in the Transformers docs</a>.',W,L,we='Details about the BitsAndBytesConfig can be found <a href="https://huggingface.co/docs/transformers/v4.37.2/en/main_classes/quantization#transformers.BitsAndBytesConfig" rel="nofollow">here</a>.',Y,w,D,M,K,H,O,P,ve="With <code>PEFT</code>, you can use QLoRA out of the box with <code>LoraConfig</code> and a 4-bit base model.",ee,C,_e='Please review the <a href="https://huggingface.co/docs/peft/developer_guides/quantization#quantize-a-model" rel="nofollow">bitsandbytes section in the PEFT docs</a>.',te,x,ie,z,Le="Bitsandbytes is also easily usable from within Accelerate.",ne,A,Me='Please review the <a href="https://huggingface.co/docs/accelerate/en/usage_guides/quantization" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',ae,B,le,q,He="Bitsandbytes is available from within both",se,J,Pe='<li><a href="https://lightning.ai/docs/pytorch/stable/" rel="nofollow">PyTorch Lightning</a>, a deep learning framework for professional AI researchers and machine learning engineers who need maximal flexibility without sacrificing performance at scale;</li> <li>and <a href="https://lightning.ai/docs/fabric/stable/" rel="nofollow">Lightning Fabric</a>, a fast and lightweight way to scale PyTorch models without boilerplate).</li>',oe,k,Ce='Please review the <a href="https://lightning.ai/docs/pytorch/stable/common/precision_intermediate.html#quantization-via-bitsandbytes" rel="nofollow">bitsandbytes section in the PyTorch Lightning docs</a>.',re,R,fe,E,xe='Bitsandbytes is integrated into <a href="https://github.com/Lightning-AI/lit-gpt" rel="nofollow">Lit-GPT</a>, a hackable implementation of state-of-the-art open-source large language models, based on Lightning Fabric, where it can be used for quantization during training, finetuning, and inference.',pe,F,ze='Please review the <a href="https://github.com/Lightning-AI/lit-gpt/blob/main/tutorials/quantize.md" rel="nofollow">bitsandbytes section in the Lit-GPT quantization docs</a>.',me,I,ce,X,Ae="You can use any of the 8-bit and/or paged optimizers by simple passing them to the <code>transformers.Trainer</code> class on initialization.All bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>).",ue,Z,Be='See the <a href="https://huggingface.co/docs/transformers/main_classes/trainer#transformers.Trainer" rel="nofollow">official API docs for reference</a>.',de,j,qe=`Here we point out to relevant doc sections in transformers / peft / Trainer + very briefly explain how these are integrated:
e.g. for transformers state that you can load any model in 8-bit / 4-bit precision, for PEFT, you can use QLoRA out of the box with <code>LoraConfig</code> + 4-bit base model, for Trainer: all bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>):`,he,U,be,G,Je='<li><a href="https://huggingface.co/blog/4bit-transformers-bitsandbytes" rel="nofollow">Making LLMs even more accessible with bitsandbytes, 4-bit quantization and QLoRA</a></li> <li><a href="https://huggingface.co/blog/hf-bitsandbytes-integration" rel="nofollow">A Gentle Introduction to 8-bit Matrix Multiplication for transformers at scale using Hugging Face Transformers, Accelerate and bitsandbytes</a></li>',ge,N,$e;return d=new Q({props:{title:"Transformers",local:"transformers",headingTag:"h1"}}),w=new Qe({props:{warning:!0,$$slots:{default:[Se]},$$scope:{ctx:S}}}),M=new Ne({props:{code:"aW1wb3J0JTIwdG9yY2glMEFmcm9tJTIwdHJhbnNmb3JtZXJzJTIwaW1wb3J0JTIwQml0c0FuZEJ5dGVzQ29uZmlnJTBBJTBBcXVhbnRpemF0aW9uX2NvbmZpZyUyMCUzRCUyMEJpdHNBbmRCeXRlc0NvbmZpZyhsb2FkX2luXzRiaXQlM0RUcnVlJTJDJTIwYm5iXzRiaXRfY29tcHV0ZV9kdHlwZSUzRHRvcmNoLmJmbG9hdDE2KQ==",highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> BitsAndBytesConfig

quantization_config = BitsAndBytesConfig(load_in_4bit=<span class="hljs-literal">True</span>, bnb_4bit_compute_dtype=torch.bfloat16)`,wrap:!1}}),H=new Q({props:{title:"PEFT",local:"peft",headingTag:"h1"}}),x=new Q({props:{title:"Accelerate",local:"accelerate",headingTag:"h1"}}),B=new Q({props:{title:"PyTorch Lightning and Lightning Fabric",local:"pytorch-lightning-and-lightning-fabric",headingTag:"h1"}}),R=new Q({props:{title:"Lit-GPT",local:"lit-gpt",headingTag:"h1"}}),I=new Q({props:{title:"Trainer for the optimizers",local:"trainer-for-the-optimizers",headingTag:"h1"}}),U=new Q({props:{title:"Blog posts",local:"blog-posts",headingTag:"h1"}}),{c(){f=s("meta"),v=a(),u=s("p"),m=a(),h(d.$$.fragment),p=a(),c=s("p"),c.textContent=Te,V=a(),_=s("p"),_.innerHTML=ye,W=a(),L=s("p"),L.innerHTML=we,Y=a(),h(w.$$.fragment),D=a(),h(M.$$.fragment),K=a(),h(H.$$.fragment),O=a(),P=s("p"),P.innerHTML=ve,ee=a(),C=s("p"),C.innerHTML=_e,te=a(),h(x.$$.fragment),ie=a(),z=s("p"),z.textContent=Le,ne=a(),A=s("p"),A.innerHTML=Me,ae=a(),h(B.$$.fragment),le=a(),q=s("p"),q.textContent=He,se=a(),J=s("ul"),J.innerHTML=Pe,oe=a(),k=s("p"),k.innerHTML=Ce,re=a(),h(R.$$.fragment),fe=a(),E=s("p"),E.innerHTML=xe,pe=a(),F=s("p"),F.innerHTML=ze,me=a(),h(I.$$.fragment),ce=a(),X=s("p"),X.innerHTML=Ae,ue=a(),Z=s("p"),Z.innerHTML=Be,de=a(),j=s("p"),j.innerHTML=qe,he=a(),h(U.$$.fragment),be=a(),G=s("ul"),G.innerHTML=Je,ge=a(),N=s("p"),this.h()},l(e){const t=Ue("svelte-u9bgzb",document.head);f=o(t,"META",{name:!0,content:!0}),t.forEach(i),v=l(e),u=o(e,"P",{}),Re(u).forEach(i),m=l(e),b(d.$$.fragment,e),p=l(e),c=o(e,"P",{"data-svelte-h":!0}),r(c)!=="svelte-umvy4"&&(c.textContent=Te),V=l(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1hjynvs"&&(_.innerHTML=ye),W=l(e),L=o(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-1peqy09"&&(L.innerHTML=we),Y=l(e),b(w.$$.fragment,e),D=l(e),b(M.$$.fragment,e),K=l(e),b(H.$$.fragment,e),O=l(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1pzo32b"&&(P.innerHTML=ve),ee=l(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-gc66sr"&&(C.innerHTML=_e),te=l(e),b(x.$$.fragment,e),ie=l(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-yklqdi"&&(z.textContent=Le),ne=l(e),A=o(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-f0p65c"&&(A.innerHTML=Me),ae=l(e),b(B.$$.fragment,e),le=l(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-fwwq6x"&&(q.textContent=He),se=l(e),J=o(e,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-jsr43i"&&(J.innerHTML=Pe),oe=l(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-bgq7h4"&&(k.innerHTML=Ce),re=l(e),b(R.$$.fragment,e),fe=l(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-gins1u"&&(E.innerHTML=xe),pe=l(e),F=o(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-pd1i6i"&&(F.innerHTML=ze),me=l(e),b(I.$$.fragment,e),ce=l(e),X=o(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-1lta7zi"&&(X.innerHTML=Ae),ue=l(e),Z=o(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-l324p4"&&(Z.innerHTML=Be),de=l(e),j=o(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1auupce"&&(j.innerHTML=qe),he=l(e),b(U.$$.fragment,e),be=l(e),G=o(e,"UL",{"data-svelte-h":!0}),r(G)!=="svelte-1opwyey"&&(G.innerHTML=Je),ge=l(e),N=o(e,"P",{}),Re(N).forEach(i),this.h()},h(){Ee(f,"name","hf:doc:metadata"),Ee(f,"content",We)},m(e,t){Ge(document.head,f),n(e,v,t),n(e,u,t),n(e,m,t),g(d,e,t),n(e,p,t),n(e,c,t),n(e,V,t),n(e,_,t),n(e,W,t),n(e,L,t),n(e,Y,t),g(w,e,t),n(e,D,t),g(M,e,t),n(e,K,t),g(H,e,t),n(e,O,t),n(e,P,t),n(e,ee,t),n(e,C,t),n(e,te,t),g(x,e,t),n(e,ie,t),n(e,z,t),n(e,ne,t),n(e,A,t),n(e,ae,t),g(B,e,t),n(e,le,t),n(e,q,t),n(e,se,t),n(e,J,t),n(e,oe,t),n(e,k,t),n(e,re,t),g(R,e,t),n(e,fe,t),n(e,E,t),n(e,pe,t),n(e,F,t),n(e,me,t),g(I,e,t),n(e,ce,t),n(e,X,t),n(e,ue,t),n(e,Z,t),n(e,de,t),n(e,j,t),n(e,he,t),g(U,e,t),n(e,be,t),n(e,G,t),n(e,ge,t),n(e,N,t),$e=!0},p(e,[t]){const ke={};t&2&&(ke.$$scope={dirty:t,ctx:e}),w.$set(ke)},i(e){$e||($(d.$$.fragment,e),$(w.$$.fragment,e),$(M.$$.fragment,e),$(H.$$.fragment,e),$(x.$$.fragment,e),$(B.$$.fragment,e),$(R.$$.fragment,e),$(I.$$.fragment,e),$(U.$$.fragment,e),$e=!0)},o(e){T(d.$$.fragment,e),T(w.$$.fragment,e),T(M.$$.fragment,e),T(H.$$.fragment,e),T(x.$$.fragment,e),T(B.$$.fragment,e),T(R.$$.fragment,e),T(I.$$.fragment,e),T(U.$$.fragment,e),$e=!1},d(e){e&&(i(v),i(u),i(m),i(p),i(c),i(V),i(_),i(W),i(L),i(Y),i(D),i(K),i(O),i(P),i(ee),i(C),i(te),i(ie),i(z),i(ne),i(A),i(ae),i(le),i(q),i(se),i(J),i(oe),i(k),i(re),i(fe),i(E),i(pe),i(F),i(me),i(ce),i(X),i(ue),i(Z),i(de),i(j),i(he),i(be),i(G),i(ge),i(N)),i(f),y(d,e),y(w,e),y(M,e),y(H,e),y(x,e),y(B,e),y(R,e),y(I,e),y(U,e)}}}const We='{"title":"Transformers","local":"transformers","sections":[],"depth":1}';function Ye(S){return Ie(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class it extends Ze{constructor(f){super(),je(this,f,Ye,Ve,Fe,{})}}export{it as component};
